/*
 * PROJECT C Library, X68000 PROGRAMMING INTERFACE DEFINITION
 * --------------------------------------------------------------------
 * This file is written by the Project C Library Group,  and completely
 * in public domain. You can freely use, copy, modify, and redistribute
 * the whole contents, without this notice.
 * --------------------------------------------------------------------
 * $Id: close.c,v 1.5 1994/11/26 15:10:00 mura Exp $
 */

/* System headers */
#include <errno.h>
#include <unistd.h>
#include <sys/dos.h>
#include <sys/xglob.h>
#include <sys/xunistd.h>

/* Functions */
int close (int fd)
{
#ifndef ORIGINAL_SOURCE
    int devmode;
#endif
    int mode, rc;
    char *fname;

#ifdef EBADF_CHECKER
    /* sȃt@Cnhǂׂ */
    if (_usedfd (fd) < 0) {
	errno = EBADF;
	return -1;
    }
#endif

    /* LN^foCX? */
    if (_fddb[fd].cdev) {

	/* AvP[Ṽt@CnhۂɃN[Y */
#ifndef ORIGINAL_SOURCE
	/* ܂foCX[h߂ */
	devmode = _dos_ioctrlst (fd, _fddb[fd].iomd);
#endif
	if ((rc = _dos_close (fd)) < 0) {
#ifndef ORIGINAL_SOURCE
	    /* G[Ȃ猳ɖ߂ */
	    _dos_ioctrlst (fd, devmode);
#endif
	    errno = _errcnv (rc);
	    return -1;
	}

    }

    /* ubNfoCX... */
    else {

	/* t@Co */
	fname = _fddb[fd].abspath;

	/* Ō̃t@C[h擾 (Human ̂) */
	mode = _dos_chmod (fname, -1);

	/* AvP[Ṽt@CnhۂɃN[Y */
#ifndef ORIGINAL_SOURCE
	/* ܂foCX[h߂ */
	devmode = _dos_ioctrlst (fd, _fddb[fd].iomd);
#endif
	if ((rc = _dos_close (fd)) < 0) {
#ifndef ORIGINAL_SOURCE
	    /* G[Ȃ猳ɖ߂ */
	    _dos_ioctrlst (fd, devmode);
#endif
	    errno = _errcnv (rc);
	    return -1;
	}

	/* Ɏ擾łꍇAꂪ close ɕωǂ */
	if (mode >= 0 && _dos_chmod (fname, -1) != mode)
	    _dos_chmod (fname, mode);

    }

    /* _handles \̂폜 */
    return _close (fd);
}
