/*
 * PROJECT C Library, X68000 PROGRAMMING INTERFACE DEFINITION
 * --------------------------------------------------------------------
 * This file is written by the Project C Library Group,  and completely
 * in public domain. You can freely use, copy, modify, and redistribute
 * the whole contents, without this notice.
 * --------------------------------------------------------------------
 * $Id: dup2.c,v 1.3 1994/07/27 13:53:17 mura Exp $
 */

/* System headers */
#include <unistd.h>
#include <errno.h>
#include <string.h>
#include <sys/xglob.h>
#include <sys/xunistd.h>

/* Functions */
int dup2 (int fd1, int fd2)
{
#ifndef ORIGINAL_SOURCE
    int devmode;
#endif
    int rc;


#ifdef EBADF_CHECKER
    /* t@Cnh`FbN */
    if (_usedfd (fd1) < 0) {
	errno = EBADF;
	return -1;
    }
#endif

    /* fd1  fd2 ꍇ... */
    if (fd1 == fd2)
	return fd2;

    /* ܂ fd2 N[Y */
    if (_usedfd (fd2) >= 0)
	close (fd2);

    /* ۂ dup2  */
    if ((rc = _dos_dup2 (fd1, fd2)) < 0) {
	errno = _errcnv (rc);
	return -1;
    }

#ifndef ORIGINAL_SOURCE
    /* RAW/COOKED[h̕ۑ */
    devmode = _dos_ioctrlgt (fd2) & ~_DEV_RAW;
    devmode |= _fddb[fd1].iomd & _DEV_RAW;
    _dos_ioctrlst (fd2, devmode);
#endif

    /* fd2 ɑ΂ _handles \̂쐬 */
    if (_open (_fddb[fd1].abspath, fd2, _fddb[fd1].oflag) < 0)
	return -1;

    /* fd2 Ԃ */
    return fd2;
}
